/// <reference path="../../js/ui.js" />

(function (UIOnline, $, __ACc, undefined) {

	/*
	Note to modders:
	It'll be much easier to create a stand-alone module for any modifications you require.
	This will guarantee that any additions you make aren't overwritten by updates.
	As an example look at the "Clock" module in the modules folder.
	*/

	var _container, _language, _searchtimer, _msgtimer,
	    _sortby, _inverse = false, _servers,
	    _selectedServerEntry = null,
		_joinguid, _checkedfreejoinversion = false, _wantRefresh = false,
		_bookedServer, _onlineTimer = 0, _detailTimer, _onlinecar, _refreshing = false, _makingbooking = false, _refreshlingplayers = false, _displayedwarning = false, _pingingservers = false, _debouncetimer = {}, _pingtimers = [], _currentrequest, _joinedservers = [];

	var $container,
		$serverdetails = $(".list .serverdetails", _container),
		$msg = $(".serverdetails .container .message", _container),
		$btnBook = $(".serverdetails .servercontrols .button[data-mode=booking]", _container),
		$btnCancel = $(".serverdetails .servercontrols .button[data-mode=unsubscribe]", _container),
		$onlineTimer, $dialogPassword;

	var cars = __AC.Cars,
	    tracks = __AC.Tracks;

	var timerPosition = { x: null, y: null };

	function initOnline(c, l) {
		_container = c;
		_language = l;

		$container = $(c);

		$("<link/>", {
			rel: "stylesheet",
			type: "text/css",
			href: "modules/online/online.css?" + Date.now()
		}).appendTo("head");

		if ($("#wrapper > div.onlineTimer").length == 0) {
			$onlineTimer = $("div.onlineTimer", _container);
			$onlineTimer.appendTo("#wrapper");

			$onlineTimer.enabledrag({
				mouseup: function (x, y) {
					timerPosition.x = x, timerPosition.y = y;
					$onlineTimer.removeClass("drag").css("-webkit-transition", "");
				}
			}).mousedown(function () {
				$onlineTimer.addClass("drag").css("-webkit-transition", "box-shadow 0.5s");
			});
		}

		bindControls();
		console.log(">>> UIOnline init", _container);
	}

	var filter = {};

	function initDialogs() {

	}

	var isChecked = function (option) {
		return $(".controls input[type=checkbox][data-mode='" + option + "']", _container).prop("checked");
	};

	var updateFilter = function () {
		$(".controls input[type=checkbox][data-mode]", _container).each(function () {
			var mode = $(this).data("mode");
			if (mode) filter[mode] = $(this).prop("checked");
		});
	};

	function isFreejoin(server) {
		return server.name.indexOf("[FREEJOIN]") > -1		
	}	
	
	var applyFilter = function () {
		var $items = $(".online .list .item");
		$items.each(function () {
			var $this = $(this), server = $this.data("server");

			$this.toggleClass("hidden",
				(server.clients == 0 && !filter.empty && !filter.freejoin) ||
				(server.clients == server.maxclients && !filter.full && !filter.freejoin) ||
				(server.session != 0 && filter.booking && !filter.freejoin) ||
				(server.pass && !filter.locked) ||
				(!isFreejoin(server) && filter.freejoin) ||
				(_joinedservers.indexOf(server.ip + "_" + server.port) == -1 && filter.joined)
			);
			if ($this.hasClass("selected") && $this.hasClass("hidden"))
				hideServerDetails();
		});
		$("thead .name span > span", _container).html($(".online .list .item:not(.hidden)").length + "/" + $items.length);
	};

	function doDebounce(timer, target, time, extrafunction) {
		if (!time) time = 5000;
		_debouncetimer[timer] = setTimeout(function () {
			_debouncetimer[timer] = null;
			target.removeClass("disabled");
			if (typeof extrafunction === "function") extrafunction();
		}, time);
	}

	function bindControls() {

		$(document).on("click", _container + " .link", function () {
			$.ACCall("browseto", "url=" + $(this).data("url"));
		})

		UI.bind.widgets(_container + " .list .controls");

		updateFilter();

		$(document).on("mousewheel", _container + " .tdatalist", function (e) {
			var e0 = e.originalEvent,
				delta = e0.wheelDelta;

			this.scrollTop += (delta < 0 ? 1 : -1) * 30;
			e.preventDefault();
		});

		$(document).on({
			click: function () {
				var $this = $(this);

				if ($this.hasClass("selected")) {
					$this.removeClass("selected");
					hideServerDetails();
				} else {
					$this.selected();
					_selectedServerEntry = $this;
					showServerDetails($this.data("server"));
					$(".tdatalist", _container).animate({ scrollTop: $this.position().top }, 500);
				}
			}
		}, _container + " .tdatalist .item");

		$("div.message", _container).on("click", function () {
			clearTimeout(_msgtimer);
			$(this).removeClass("active");
		});

		$container.on("click", ".controls .button:not(.disabled), .servercontrols .button:not(.disabled)", function (event) {
			var mode = $(this).data("mode");
			var $this = $(this);
			var server = getSelectedServerEntry().data("server");
			var handler = {
				ping: function () {
					//if (!_debouncetimer[mode]) {
					pingAll();

					//}
					//doDebounce(mode, $this);
				},
				refresh: function () {

					//if (!_debouncetimer.refresh) {
					refreshServers();
					//$this.addClass("disabled");
					//}

					//doDebounce(mode, $this);

				},
				help: function () {
					if (UIHelp) UIHelp.show("online");
				},
				booking: function () {
					if (server.cars.length == 1)
						$(".serverdetails .carlist .value > div", _container).eq(0).click();
					subscribe(
						server,
						UI.player.car(),
						UI.player.skin(),
						UIProfile.getFullName(),
						"",
						__AC.getPlayerGuid(),
						server.pass ? $(".serverdetails .serverpass").val() : ""
					);
					$(".disabled[data-mode=unsubscribe]").removeClass(".disabled");
				},
				reloadserver: function () {
					if (!_debouncetimer.reloadserver) {
						refreshSelectedServer();
						$this.addClass("disabled");
					}
					doDebounce(mode, $this);

				},
				playerlist: function () {

					if (!_debouncetimer.playerlist) {
						updatePlayerList(getSelectedServerEntry().data("server"));
						$this.addClass("disabled");
					}
					doDebounce(mode, $this);
				},
				unsubscribe: function () { unsubscribe(false, server) },
				join: function () {
					join(server);
				}
			}[mode]();
		});

		$container.on({
			click: function () {
				$(this).selected();
				UI.player.setCar(cars[$(this).data("id")]);
				_onlinecar = $(this).data("id");
			}
		}, ".carlist .value > div:not(.unknown)");

		$container.on({
			click: function () {
				$(this).selected();
				_joinguid = $(this).data("id");
			}
		}, ".playerlist .value > div:not(.unknown)");
		
		$onlineTimer.on("click", ".controls span", function () {
			var mode = $(this).data("mode");
			var handler = {
				unsubscribe: unsubscribe,
				join: join
			}[mode]();
		});

		function applyTextFilter() {
			var searchbox = $(".controls .serversearch", _container);
			$(".tdatalist .item:not(.selected):not(.hidden)", _container).each(function () {
				//var search = $(".name", $(this)).text().toLowerCase();

				var search = [];
				search.push($(".name", $(this)).text());
				//search.push(c.brand);
				//if ($(this).hasClass("selected")) search.push("selected");
				//search = search.concat(c.tags);
				search = search.toString().toLowerCase();
				var fullstr = searchbox.val().toLowerCase();
				var splitstr = fullstr.replace(/(!\S+)/g, "").match(/\S+/g);
				var excludestr = fullstr.match(/(!\S+)/g);

				var tofind = splitstr ? "(" + splitstr.join("|") + ")" : "";

				var exclude = excludestr ? "(" + excludestr.join("|").replace(/!/g, "") + ")" : "NONEEXCLUDED";

				if (splitstr) {

					if (search.match(new RegExp(tofind, 'g')) && !search.match(new RegExp(exclude, 'g')))
						$(this).removeClass("keyfiltered");
					else
						$(this).addClass("keyfiltered");
				}
				else {

					if (search.match(new RegExp(exclude, 'g')))
						$(this).addClass("keyfiltered");
					else
						$(this).removeClass("keyfiltered");
				}

				/*if (search.indexOf(searchbox.val().toLowerCase()) > -1)
					$(this).removeClass("keyfiltered");
				else
					$(this).addClass("keyfiltered");*/
			});
		}

		$(".controls .serversearch", _container).on({
			keyup: function (e) {
				var searchbox = $(this);
				if (searchbox.val().length > 1) {
					window.clearTimeout(_searchtimer);

					if (e.isTrigger) applyTextFilter();
					else
						_searchtimer = window.setTimeout(applyTextFilter, 500);
				} else {
					window.clearTimeout(_searchtimer);
					$(".tdatalist .item", _container).removeClass("keyfiltered");
				}
				$(".serversearch", _container).not(this).val($(this).val());
			}
		});

		$("thead td", _container).on("click", function () {

			$(this).selected().toggleClass("inverted", _inverse)
					.siblings().removeClass("inverted");

			_sortby = $(this).data("mode");

			sortBy(_sortby, _inverse);

			_inverse = !_inverse;

		});

		$("input[type=checkbox][data-mode]", _container).on("click", function () {
			var mode = $(this).data("mode");
			filter[mode] = isChecked(mode);
			applyFilter();
		});
	}

	function sortBy(colname, invert) {
		console.log("UIOnline >>> sorting by:", colname, invert);
		$(".tdatalist td." + colname, _container).sortElements(function (a, b) {

			a = $(".value", a).text();
			b = $(".value", b).text();
			a = isNaN(a) ? a : +a;
			b = isNaN(b) ? b : +b;
			if (colname == "ping") {
				a = isNaN(a) ? (invert ? -1 : 1) * 90000 : a;
				b = isNaN(b) ? (invert ? -1 : 1) * 90000 : b;
			}
			return (a > b) ? (invert ? -1 : 1) : (invert ? 1 : -1);
		}, function () {
			return this.parentNode;
		});

		if ($("item.selected", _container).length > 0)
			$(".tdatalist", _container).animate({ scrollTop: $(".item.selected", _container).position().top }, 500);
	}

	function showMsg(msgtext, timeout, cssclass) {
		console.log(msgtext);
		if (!timeout) timeout = 3000;
		$msg.html(msgtext).addClass("active");
		if (cssclass) $msg.addClass(cssclass);
		_msgtimer = window.setTimeout(function () {
			$msg.removeClass("active");
			if (cssclass) $msg.removeClass(cssclass);
		}, timeout);
	}

	function resetTimerPanel() {
		$onlineTimer.removeClass("active ready").removeAttr("style");
	}

	var _canjoin;

	function join(server, wantguid) {
		var targetserver, guid = __AC.getPlayerGuid();

		guid = wantguid || guid;
		
		if(server && !wantguid && isFreejoin(server))
		{
			joinid = _joinguid;		
			if(joinid == -1)
			{
				showMsg("Select a free slot");
				return;
			}
			passwd = $(".serverdetails .serverpass").val();
			msgServerPy(server, "REQJOIN", passwd, joinid, __AC.getPlayerGuid(), UIProfile.getFullName(), function (response) {
			
				var data = response.split('|');
				var status = data[0];		
				var msg = data[1];
				
				console.log("Response: "+ response);
				console.log("status: "+ status);
				console.log("msg: "+ msg);
				
				_canjoin = status != "NO";
				if (!_canjoin) showMsg("Could not connect: "+msg);
				else join(server, msg)
			});
			return;
		}
		
		if (server) {
			if (_canjoin === true) {
				if (_bookedServer
					&& _bookedServer.ip != server.ip
					&& _bookedServer.port != server.port) unsubscribe();
				$.ACSet("race?REMOTE/SERVER_IP", server.ip);
				$.ACSet("race?REMOTE/SERVER_PORT", server.port);

				if ((UIProfile.getFirstName() + UIProfile.getLastName()).replace(/ /g, "") == "") {
					$.ACSet("race?REMOTE/FIRST_NAME", UIProfile.getNickName());
					$.ACSet("race?REMOTE/LAST_NAME", " ");
				} else {
					$.ACSet("race?REMOTE/FIRST_NAME", UIProfile.getFirstName());
					$.ACSet("race?REMOTE/LAST_NAME", UIProfile.getLastName() + " ");
				}
				$.ACClearSections("CAR_");

				$.ACSet("race?CAR_0/SETUP", "");
				$.ACSet("race?CAR_0/MODEL", "-");
				$.ACSet("race?CAR_0/SKIN", UI.player.skin());
				$.ACSet("race?CAR_0/DRIVER_NAME", UIProfile.getFullName());
				$.ACSet("race?CAR_0/NATIONALITY", UIProfile.getCountry());

				$.ACSet("race?REMOTE/GUID", guid);
			}
			targetserver = server;
		} else {
			if (!$onlineTimer.hasClass("ready")) return;
			targetserver = _bookedServer;
		}

		if (!_canjoin)
			msgServer(targetserver, "CANJOIN", guid, function (response) {
				_canjoin = response == "YES";
				if (_canjoin) join(targetserver);
				else showMsg("Cannot join server currently, please refresh the server info.");
			});

		if (typeof _canjoin === "undefined") return;

		if (_canjoin === false) {
			if(isFreejoin(server))
			showMsg("Cannot join server, refresh and select a free slot.");
			else
			showMsg("Cannot join server currently, please refresh the server info.");			
			return;
		}

		$.ACSet("race?REPLAY/ACTIVE", 0);
		$.ACSet("race?REMOTE/ACTIVE", 1);

		$("html,body").addClass("ACactive");
		_canjoin = undefined;

		$.ACCall("start");
		resetTimerPanel();
		_joinedservers.push(server.ip + "_" + server.port);

		console.log("UIOnline >>> joining " +
					targetserver.name + " ::: " +
					targetserver.ip + ":" + targetserver.port);
	    if(!isFreejoin(server))
			hideServerDetails();
		else
			_wantRefresh = true;
		_bookedServer = null;
	}

	function isBookedServer(server) {
		if (!server) return false;
		return (_bookedServer &&
			(_bookedServer.ip == server.ip && _bookedServer.port == server.port) ? true : false);
	}

	function doTimers() {		
		if(_wantRefresh && !($("html,body").hasClass("ACactive")))
		{
			refreshSelectedServer();
			_wantRefresh = false;
		}
		$(".tdatalist .item").each(function () {
			var $this = $(this),
			    server = $this.data("server");
			if (server.session == 3 || (isBookedServer(server) && server.session == 0)) return;
			if (server.timeleft > 0) server.timeleft--;
			if ($this.hasClass("selected")) updateSessionList(server);
		});
	}

	function subscribe(server, car, skin, driver, team, guid, password) {

		if (_makingbooking) return;

		var params = [car.id, skin, driver.replace(/\|/g, "."), team.replace(/\|/g, "."), guid, password];

		var url = "http://" + server.ip + ":" + server.cport + "/SUB|" + encodeURIComponent(params.join("|"));
		console.log("UIOnline >>>", "SUB", "prev", _bookedServer);
		console.log("UIOnline >>>", "booking", server.name);
		_makingbooking = true;

		_currentrequest = $.ajax({
			url: url,
			async: true,
			timeout: 30000,
			cached: false
		}).done(function (data) {

			var response = data.split(",");
			var timeleft = parseInt(response[1]) + 5;
			console.log("server responds: " + timeleft, timeleft * 1000);

			var h = {

				"ILLEGAL CAR": function () {
					showMsg("Please select a car supported by the server.");
					$(".serverdetails .carlist", _container).removeClass("highlight", 2000).addClass("highlight");

				},

				"INCORRECT PASSWORD": function () {
					showMsg("The password you have provided is not valid.");
				},

				CLOSED: function () {
					showMsg("Server not currently accepting bookings.");
					$btnBook.addClass("disabled");
				},
				BLACKLISTED: function () {
					showMsg("You have been blacklisted on this server.");
					$btnBook.addClass("disabled");
				},
				OK: function () {
					if (password) {
						__AC.setDbValue("serverpass_" + server.name, password);
					}

					unsubscribe(true, _bookedServer, function () {

						showMsg("Booking made, next session starts in " + $.formatTime(timeleft * 1000, true) + "");

						$(".servername", $onlineTimer).text(server.name);
						$(".trackname", $onlineTimer).text(tracks[server.track].name);
						$(".carname", $onlineTimer).text(cars[_onlinecar].name);
						$(".bgr", $onlineTimer).css("background-image", "url('" + tracks[server.track].preview + "')");

						startOnlineTimer();
						_bookedServer = server;
						_bookedServer.timeleft = timeleft;
						if (timerPosition.x != null && timerPosition.y != null)
							$onlineTimer.css("top", timerPosition.y).css("left", timerPosition.x);
						$onlineTimer.addClass("active");
						//$btnBook.addClass("disabled");
						$btnCancel.removeClass("disabled");

						$.ACSet("race?REMOTE/SERVER_IP", server.ip);
						$.ACSet("race?REMOTE/SERVER_PORT", server.port);
						$.ACSet("race?REMOTE/FIRST_NAME", UIProfile.getFirstName());
						$.ACSet("race?REMOTE/LAST_NAME", UIProfile.getLastName() + " ");
						$.ACSet("race?REMOTE/GUID", guid);

						//_selectedServerEntry = getSelectedServerEntry();
						_selectedServerEntry.data("server").clients++;
						//console.log("selected", _selectedServerEntry.data("server"));
						updateServerEntry(_selectedServerEntry);

						console.log("UIOnline >>>", "booking success", server.name);
					}, _bookedServer == server);
				},

				"SERVER FULL": function () {
					showMsg("Server full.");
					//$btnBook.addClass("disabled");
				}
			};
			if (h[response[0].toUpperCase()]) h[response[0].toUpperCase()]();
			else {
				showMsg("Server responded with: " + response[0]);
				console.log(">>> Online " + response);
				console.log(">>> Online " + url);
			}

			_makingbooking = false;

		}).error(function (err) {
			unableToContact(server.name);
			_makingbooking = false;
		});
	}

	function unableToContact(servername) {
		showMsg("Unable to contact server: " + servername);
	}

	function unsubscribe(show, server, callback, condition) {

		if ((!_bookedServer && !server) || condition) {
			if (typeof callback === "function") callback();
			console.log("unsub not required");
			return;
		}

		var targetserver = server ? server : _bookedServer;


		var unsubname = targetserver.name;
		var url = "http://" + targetserver.ip + ":" + targetserver.cport + "/UNSUB|" + __AC.getPlayerGuid();
		console.log("UIOnline >>>", "unsub request", unsubname);

		_currentrequest = $.ajax({
			url: url,
			async: true,
			timeout: 30000,
			cached: false
		}).done(function (data) {
			if (server && _bookedServer != server) {
				console.log("UIOnline >>>", "unsub success", unsubname);
				updatePlayerList(targetserver);
				delete server.hasPlayer;
				return;
			}

			clearInterval(_onlineTimer);

			if (!show) {
				resetTimerPanel();
				hideServerDetails();
				$(".tdatalist .item", _container).removeClass("selected");
			}

			_bookedServer = null;

			var bookedserverentry = getBookedServerEntry();

			var bookedserverentryserver = getBookedServerEntry().data("server");
			//console.log(bookedserverentry, bookedserverentryserver);

			bookedserverentryserver.clients--;
			updateServerEntry(bookedserverentry, bookedserverentryserver);

			bookedserverentry.removeClass("currentlybooked");

			console.log("UIOnline >>>", "unsub success", unsubname);

			if (typeof callback === "function") callback();
		}).error(function (err) {
			unableToContact(unsubname);
		});;
	}

	function startOnlineTimer() {

		clearInterval(_onlineTimer);

		_onlineTimer = setInterval(function () {
			if (!_bookedServer) {
				clearInterval(_onlineTimer);
				resetTimerPanel();
			}

			if (_bookedServer.timeleft > 0) {
				_bookedServer.timeleft--;
			} else {
				$onlineTimer.addClass("ready");
				clearInterval(_onlineTimer);
				_bookedServer.session = _bookedServer.sessiontypes[1];
				_bookedServer.timeleft = _bookedServer.durations[1];
				updatePlayerList(getSelectedServerEntry().data("server"));
				//refreshServers();
				return;
			}
			$(".timer .value", $onlineTimer).html($.formatTime((_bookedServer.timeleft) * 1000, true));
			if (isBookedServer(getSelectedServerEntry().data("server")))
				updateSessionList(_bookedServer);

		}, 1000);
	}

	function refreshSelectedServer() {
		var server = getSelectedServerEntry().data("server");
		console.log("refreshing ", server);
		$(".serverdetails", _container).addClass("loading");

		_currentrequest = $.ajax({
			url: UIOnline.LAN ? "http://" + server.ip + ":" + server.cport + "/INFO" : "ac://getserver",
			async: true,
			timeout: 120000,
			data: { async: true, ip: server.ip, port: server.port },
			dataType: "json",
			cache: false
		}).done(function (data) {
			//var server = data;
			if (UIOnline.LAN) {
				data.ip = server.ip;
				data.l = true;
			}
			getSelectedServerEntry().data("server", data);
			updateServerEntry(getSelectedServerEntry(), data);
		}).error(function (xhr, status, error) {
			unableToContact(server.name);
		}).always(function () {
			$(".serverdetails", _container).removeClass("loading");
		});

	}

	function refreshServers() {
		if (_refreshing) {
			console.log(">>> UIOnline : currently refreshing");
			return;
		}

		if (!__AC.getDbValue("onlinedisclaimer")) {
			UI.closeOverlay(true);
			UI.displayDialog(
				".yesno",
				$(".disclaimer", _container).clone(),
				function () {
					UI.closeDialog(true, "withlogo onlinedisclaimer");
					UI.closeOverlay(true);
					__AC.setDbValue("onlinedisclaimer", true);
					refreshServers();
				}, function () {
					$("#drive .tabs div[data-mode=practice]").click();
					UI.closeDialog();
				}, "I agree", "I disagree", "withlogo onlinedisclaimer");
			return;
		}

		if (!_displayedwarning) {
			UI.closeOverlay(true);
			UI.displayDialog(
				".notice",
				$(".featurewarning", _container).clone(),
				function () {
					UI.closeDialog(true, "withlogo featurewarning");
					UI.closeOverlay(true);
					_displayedwarning = true;
					refreshServers();
				},
				null, "continue", null, "withlogo featurewarning", true);
			return;
		}

		if(!_checkedfreejoinversion) {		
			$.ajax({
				url: "http://www.kegetys.fi/freejoin/LATEST_VERSION",
				async: true,
				timeout: 2500,
				data: { version:"3.0" },
				dataType: "json",
				cache: false
			}).done(function (data) {
				if(parseInt(data) > 3) {
					UI.displayDialog(
						".notice",
						$(".freejoinversion", _container).clone(),
						function () {
							UI.closeDialog(true, "withlogo freejoinversion");
							UI.closeOverlay(true);					
							refreshServers();
						},
						null, "continue", null, "withlogo freejoinversion", true);
					return;					
				}
			}).always(function() {
			});		
			
			_checkedfreejoinversion = true;
		}
		
		_refreshing = true;

		if (!_bookedServer)
			hideServerDetails();

		var list = $(".tdatalist", _container);
		var template = $("table.template .item", _container);
		list.html("<tr class='spacer'></tr>");
		$container.addClass("loading");
		$(".button[data-mode=ping], .button[data-mode=refresh]", _container).addClass("disabled");

		_currentrequest = $.ajax({
			url: UIOnline.LAN ? "ac://getlanservers?async=true" : "ac://getserverlist?async=true",
			async: true,
			timeout: 120000,
			dataType: "json",
			cache: false
		}).done(function (data) {
			_servers = data;

			$.each(data, function (index, server) {
				try {
					var item = template.clone(false);
					updateServerEntry(item, server);
					list.append(item);
				} catch (err) {
					console.log(err.stack);
				}
			});

			if ($(".currentlybooked", list).length == 0) {
				if (_bookedServer) $("#msg").addMsg($.getl18n("previously booked server unavailable", _language), "controller_msg", true, 6000);
				resetTimerPanel();
				_bookedServer = null;
				clearInterval(_onlineTimer);
				hideServerDetails();

			}

			if (_sortby == "name" || _sortby == "clients")
				sortBy(_sortby, !_inverse);

			applyFilter();
			$(".controls .serversearch", _container).keyup();

			if (_servers.length > 0)
				setTimeout(pingAll, 1000);
			else {
				if (UIOnline.LAN)
					$("#msg").addMsg($.getl18n("No servers found on LAN. Please check firewall configuration and set server UDP port in the 9000 to 10000 range.", _language), "controller_msg", true, 15000);
				$(".button[data-mode=ping], .button[data-mode=refresh]", _container).removeClass("disabled");
				_pingingservers = false;
			}

			clearInterval(_detailTimer);
			_detailTimer = setInterval(doTimers, 1000);
			_refreshing = false;


			$("thead .name span > span", _container).html(data.length);

		}).error(function (xhr, status, error) {
			$(".button[data-mode=refresh]", _container).removeClass("disabled");

			if (status != "abort") {
				console.log("Cannot contact lobby " + xhr.responseText + " // " + status + " // " + error);
				$("#msg").addMsg($.getl18n("cannot retrieve list of servers", _language), "controller_msg", true, 6000);
			}

		}).always(function () {
			_refreshing = false;
			$container.removeClass("loading");
		});

	}

	function updateServerEntry(item, server, silent) {

		if (!server) server = item.data("server");

		var timeoffset = Math.round(server.timestamp / 1000);

		//console.log("offset", timeoffset, "timeleft", server.timeleft, "diff", server.timeleft - timeoffset);

		//if (server != _bookedServer)
		server.timeleft = server.timeleft - timeoffset;
		if (server.timeleft < 0) server.timeleft = 0;

		var stypes = ["B", "P", "Q", "R"];

		item.addClass("sessiontype" + server.session);
		
		if(isFreejoin(server))
		{
			server.maxclients = server.clients;
			server.clients = "?";
		}

		$(".name .value", item).text(server.name);
		$(".clients .value", item).text(server.clients);
		$(".clients .max", item).text(server.maxclients);
		$(".trackname", item).text(tracks[server.track] ? tracks[server.track].name : server.track);

		$(".servercars", item).html("");
		$(".sessiontypes", item).html("");

		if (!tracks[server.track]) {
			$(".trackname", item).addClass("unknown");
			item.addClass("unknowntrack");
		}

		if (tracks[server.track] && tracks[server.track].pitboxes) {
			if (tracks[server.track].pitboxes < server.maxclients) item.addClass("pitslotsexceeded");
		}

		$(".serverlocation", item).text(server.country[0]);

		$.each(server.sessiontypes, function (stindex, sessiontype) {
			var st = $("<span/>").text(stypes[sessiontype]);
			if (sessiontype == server.session) st.addClass("active");
			$(".sessiontypes", item).append(st);
		});

		$.each(server.cars, function (carindex, carid) {
			carid = carid.toLowerCase();
			var cr = $("<span/>");
			if (!cars[carid]) {
				cr.addClass("unknown");
				item.addClass("unknowncar");
			}
			var c = cars[carid] ? cars[carid].name : carid;
			cr.text(c);
			$(".servercars", item).append(cr);
		});

		if ($(".ping .value", item).text() == "...")
			$(".ping .value", item).addClass("loading");

		if (isBookedServer(server)) {
			_bookedServer = server;
			item.addClass("currentlybooked");
		}

		item.toggleClass("passprotected", server.pass);

		if (!silent && (item.hasClass("currentlybooked") || item.hasClass("selected"))) {
			showServerDetails(server);
			item.selected();
		}

		if (silent && item.hasClass("currentlybooked") && item.hasClass("selected")) {
			showServerDetails(server);
		}


		//item.data("index", index);
		item.data("server", server);
	}

	function pingAll() {
		var sum = 0;
		var $items = $(".tdatalist .item:not(.hidden):not(.keyfiltered)", _container);
		var total = $items.length;
		var time = 50;
		var $pingcounter = $(".pingcount", _container);
		if ($items.length == 0) {
			$(".button[data-mode=ping], .button[data-mode=refresh]", _container).removeClass("disabled");
			return;
		}
		$(".button[data-mode=ping]", _container).addClass("disabled");
		$(".button[data-mode=refresh]", _container).addClass("disabled");
		if (!_pingingservers)
			$items.each(function (index, item) {
				var $this = $(this);
				var server = $this.data("server");

				var $ping = $(".ping", item).addClass("loading");
				$pingcounter.addClass("selected");
				//if (getPingAbort()) return;
				_pingtimers.push(
					setTimeout(function () {

						_pingingservers = true;
						//console.log("Pinging " + server.ip);

						_currentrequest = $.ajax({
							url: "ac://pingserver?async=true&ip=" + server.ip + "&port=" + server.port,
							async: true,
							cache: false,
							timeout: 10000
						}).done(function (pingdata) {
							//if (getPingAbort()) return;
							var pingresponse = pingdata[0];
							if (pingresponse != "-1") {
								$this.removeClass("noping");
								$ping.removeClass("loading");
								$(".value", $ping).text(pingresponse);
							} else {
								$this.addClass("noping");
								$(".value", $ping).text("n/a");
							}
							$(".pingcount > span", _container).html(sum + "/" + total);
							//console.log(sum, "Pinged " + server.ip + " : " + pingresponse + "ms");
						}).error(function () {

							$this.addClass("noping");
							$(".value", $ping).text("n/a");
							console.log(sum, "Error pinging " + server.ip);
						}).always(function () {
							//if (getPingAbort()) return;
							if (_sortby == "ping") {
								if (_debouncetimer.pingsort) clearTimeout(_debouncetimer.pingsort);
								_debouncetimer.pingsort = setTimeout(function () {
									sortBy(_sortby, !_inverse);
								}, 200);
							}
							sum++;
							if (sum == total) {
								_pingingservers = false;
								$(".button[data-mode=ping], .button[data-mode=refresh]", _container).removeClass("disabled");

								$pingcounter.removeClass("selected");
								_pingtimers = [];
							}
						});
					}, time));
				if (index % 10 == 0)
					time = time + 500;
			});

	}

	function ping(server) {

	}

	function hideServerDetails(noparent) {
		$serverdetails.removeClass("active");
		if (!noparent) $container.removeClass("showingdetails");
	}

	function showServerDetails(server) {
	
		_joinguid = -1;

		var $p = $serverdetails;
		$p.data("server", server);

		var knowntrack = typeof (tracks[server.track]) != "undefined";
		$(".servername .value", $p).html(server.name);

		$p.toggleClass("unknowntrack", !knowntrack);

		if (tracks[server.track]) {
			$(".trackname", $p).text(tracks[server.track].name);
			$(".trackoutline", $p).css("background-image", "url('" + tracks[server.track].outline + "')");
			$p.css("background-image", "url('" + tracks[server.track].preview + "')");
		} else
			$(".trackname", $p).text(server.track);

		$(".country .value", $p).html(server.country[0]);

		var unknowncar = false;

		$(".carlist", $p).removeClass("highlight");
		$(".carlist .value", $p).html("");
		$.each(server.cars, function (carindex, carid) {
			carid = carid.toLowerCase();
			var cr = $("<div/>"),
				knowncar = typeof (cars[carid]) != "undefined";

			cr.toggleClass("unknown", !knowncar);

			if (!knowncar && !unknowncar)
				unknowncar = true;

			var c = knowncar ? cars[carid].name : carid;
			cr.html("<span>" + c + "</span>");
			cr.data("id", carid);

			if (!_onlinecar) _onlinecar = UI.combo().car.id;
			if (carid == _onlinecar) cr.addClass("selected");

			if(!isFreejoin(server))
			$(".carlist .value", $p).append(cr);
		});

		$p.toggleClass("unknowncar", unknowncar);

		updateSessionList(server);
		window.setTimeout(function () {
			updatePlayerList(server);
		}, 250);

		if (unknowncar || !knowntrack)
			$(".message", _container).text("Server Contains Unavailable Content");

		var serverunavailable = (getCurrentSession(server) != 0 || server.maxclients == server.clients) && !isBookedServer(server);
		var currentserver = (isBookedServer(server)) ? false : true;

		$(".servercontrols div[data-mode=booking]").toggleClass("disabled", serverunavailable);
		$(".servercontrols div[data-mode=unsubscribe]").toggleClass("disabled", currentserver || (isBookedServer(server) && server.session != 0));

		$(".servercontrols div[data-mode=join]").toggleClass("hidden", !(isBookedServer(server) && server.session != 0));
		var $joinbtn = $(".servercontrols div[data-mode=join]");
		$joinbtn.addClass("disabled");
		doDebounce("joinbutton", $joinbtn, 100);
		if (_debouncetimer.joinButtonCountdown)
			clearInterval(_debouncetimer.joinButtonCountdown);
		var cnt = 1;
		_debouncetimer.joinButtonCountdown = setInterval(function () {
			$("span", $joinbtn).text(cnt + "sec");
			cnt--;
			if (cnt == 0) {
				$("span", $joinbtn).text("");
				clearInterval(_debouncetimer.joinButtonCountdown);
			}
		}, 0);

		$(".servercontrols div[data-mode=booking]").toggleClass("hidden", isBookedServer(server) && server.session != 0);
		//console.log(server.session, isBookedServer(server) && server.session != 0, isBookedServer(server));

		//console.log(isBookedServer(server), server.session, isBookedServer(server) && server.session != 0);

		$serverdetails.addClass("active").toggleClass("passprotected", server.pass||isFreejoin(server));
		
		$("textarea").attr("placeholder", "New placeholder text");
		
		var prevpass = __AC.getDbValue("serverpass_" + server.name);
		if (!prevpass) prevpass = "";
		$(".serverpass", $serverdetails).val(prevpass);

		if (tracks[server.track] && tracks[server.track].pitboxes) {
			if (tracks[server.track].pitboxes < server.maxclients) showMsg("<span>WARNING</span> This server's available slots exceed the number of pitboxes for " + tracks[server.track].name, 7000, "smaller");
		}

		$container.addClass("showingdetails");
	}

	function getCurrentSession(server) {
		return server.sessiontypes[server.session];
	}

	function updatePlayerList(server) {
		console.log("Updating player list " + server.ip + ":" + server.cport);
		$(".playerlist .value", $serverdetails).html("");
		$(".playerlist h3 span", $serverdetails).html("");

		if(!isFreejoin(server))
		{
			$(".playerlist h3", $serverdetails).html("Drivers on server<span></span>");
			$(".carlist h3", $serverdetails).html("Select an available car &#9660;");			
		}
		else
		{
			$(".playerlist h3", $serverdetails).html("Select free slot to join:<span></span>");
			$(".carlist h3", $serverdetails).html("");		
			msgServerPy(server, "MOTD", __AC.getPlayerGuid(), UIProfile.getFullName(), "", "", function (response) {
				if(response == "NO|Server not responding") {
					$(".carlist .value", $serverdetails).html("<span style=\"color: red;\">Server not responding</span>");
				} else {
					motd = response.replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\n/g, "</br>").replace(/&/g, "&amp;");
					$(".carlist .value", $serverdetails).html(motd);
				}
			});			
		}	
		
		var total = 0, connected = 0;
		_currentrequest = $.ajax({
			url: "http://" + server.ip + ":" + server.cport + "/JSON|" + __AC.getPlayerGuid(),
			async: true,
			timeout: 10000,
			dataType: "json",
			cache: false
		}).done(function (data) {

			if (data.Cars && data.Cars.length > 0 && !isFreejoin(server)) {

				data.Cars.sort(function (a, b) {
					try {
						var na = a.DriverName.toLowerCase(), nb = b.DriverName.toLowerCase();
						if (na < nb) return -1;
						if (na > nb) return 1;
					} catch (ex) {
						console.log("error sorting!");
						return 0;

					}
				});
			}

			delete server.hasPlayer;
			$.each(data.Cars, function (i, o) {
				total++;
				var car = cars[o.Model];
				car = (!car) ? o.Model : car.name;
				var $row = $("<div/>", {
					html: "<span>" + (o.IsConnected||!isFreejoin(server) ? o.DriverName : "[Free slot]") + "</span><span>" + car + "</span>",
					"class": (isFreejoin(server)?!o.IsConnected:o.IsConnected) ? "connected" : ""			
				}).toggleClass("isplayer", o.IsRequestedGUID);
				if (o.IsRequestedGUID) server.hasPlayer = o.IsRequestedGUID;
				if (o.IsConnected) connected++;
				if (!o.Isconnected && isFreejoin(server)) server.hasPlayer = true;
				$row.data("id", total-1);				

				$(".playerlist .value", $serverdetails).append($row);
			});
			$(".playerlist h3 span", $serverdetails).html("" + connected + "/" + total + "");

			$(".servercontrols div[data-mode=unsubscribe]").toggleClass("disabled", !server.hasPlayer || getCurrentSession(server) != 0);
			$(".servercontrols div[data-mode=join]").toggleClass("hidden", !(server.hasPlayer === true) || getCurrentSession(server) == 0);
			$(".servercontrols div[data-mode=booking]")
					.toggleClass("hidden", (server.hasPlayer === true) && getCurrentSession(server) != 0)
					.toggleClass("disabled", getCurrentSession(server) != 0);

		}).error(function (err) {
			unableToContact(server.name, err);
		});

	}

	function updateSessionList(server) {
		var stypes = ["Booking", "Practice", "Qualifying", "Race"];

		$(".sessionlist", $serverdetails).html("");

		server.sessiontypes.forEach(function (s, si) {
			var offset = 0;
			var sr = $("<div/>");
			sr.html(stypes[s]);
			var dur = $("<div/>", { "class": "duration" });
			dur.html(
				(s != 3) ?
					((server.session == s) ?
						$.formatTime(server.timeleft * 1000, true) :
						$.formatTime(server.durations[si] * 1000, true))
				:
				server.durations[si] + " Laps"
			);

			sr.toggleClass("current", server.session == s);
			sr.toggleClass("endoftime", server.session == s && server.timeleft <= 0);

			sr.append(dur);
			$(".sessionlist", $serverdetails).append(sr);
		});
	}

	function getSelectedServerEntry() {
		_selectedServerEntry = $(".tdatalist .item.selected", _container);
		return _selectedServerEntry;
	}

	function getBookedServerEntry() {
		return $(".tdatalist .item.currentlybooked", _container);
	}

	function msgServer(server, command, parameters, callback) {
		var output = "";

		_currentrequest = $.ajax({
			url: "http://" + server.ip + ":" + server.cport + "/" + command + "|" + parameters,
			async: true,
			cache: false,
			timeout: 2000
		}).done(function (msg) {
			output = msg;
			callback(output);
		}).fail(function (j, t, e) {
			callback("NO");
			console.log("ERROR > msgServer failed");
		});

		//return output;
	}

	function getPingAbort() {
		return UIOnline.pingAbort;
	}

	function msgServerPy(server, command, param1, param2, param3, param4, callback) {
		var output = "";		
		$.ajax({
			url: "http://" + server.ip + ":" + (server.cport+1) + "/" + command + "|" + param1 + "|" + param2 +"|" + param3 +"|" + param4 +"|",
			async: true,
			cache: false,
			timeout: 4000
		}).done(function (msg) {
			output = msg;
			callback(output);
		}).fail(function (j, t, e) {
			callback("NO|Server not responding");
			console.log("ERROR > msgServer failed");
		});		
	}
	
	UIOnline.Init = initOnline;
	UIOnline.refreshServers = refreshServers;
	UIOnline.getServersList = function () { return _servers; };
	//UIOnline.serverTimers = function () { return servertimers; };
	UIOnline.pingAll = pingAll;
	UIOnline.selectedServer = function () { return _selectedServerEntry; };
	UIOnline.bookedServer = function () { return _bookedServer; };
	UIOnline.filter = filter;
	UIOnline.updateFilter = updateFilter;
	UIOnline.applyFilter = applyFilter;
	UIOnline.updateServerEntry = updateServerEntry;
	UIOnline.refreshSelectedServer = refreshSelectedServer;
	UIOnline.LAN = false;
	UIOnline.pingAbort = false;
	UIOnline.Abort = function (value) {
		if (_currentrequest) _currentrequest.abort();
		$(".button[data-mode=ping]", _container).removeClass("disabled");
		$(".button[data-mode=refresh]", _container).removeClass("disabled");
		$.each(_pingtimers, function (i, v) {
			clearTimeout(v);
		});
		_pingtimers = [];
		_pingingservers = false;
	};
	UIOnline.displayWarning = function (value) {
		if (!value)
			return _displayedwarning;
		_displayedwarning = value;
	};
	UIOnline.isListEmpty = function () {
		return $(".tdatalist .item", _container).length == 0;
	};

}(window.UIOnline = window.UIOnline || {}, jQuery, __ACClasses));